#DEFINE XML_FILE	"xml_data.xml"
#DEFINE XSL_FILE	"convert.xslt"
#DEFINE OUT_FILE	"result.xml"

#DEFINE XML_VERS	"" && or ".4.0" && or ".3.0"
#DEFINE SW_NORMAL	1
#DEFINE CRLF		CHR(13) + CHR(10)

SET DEFAULT TO (LEFT(SYS(16), RAT("\", SYS(16)))) 
LOCAL lcXmlFile as String;
	,lcXslFile as String;
	,lcHtmFile as String
lcXmlFile = LOWER(FULLPATH(XML_FILE))
lcXslFile = LOWER(FULLPATH(XSL_FILE))
lcOutFile = LOWER(FULLPATH(OUT_FILE))
IF !FILE(lcXslFile)
	ERROR 101, lcXslFile
ENDIF 
IF !FILE(lcXmlFile)
	ERROR 101, lcXmlFile
ENDIF 

DECLARE INTEGER ShellExecute IN shell32.dll ;
	INTEGER, ;
	STRING @lsOperation, ;
	STRING @lsFile, ;
	STRING @lsParameters, ;
	STRING @lsDirectory, ;
	INTEGER liShowCmd
DECLARE INTEGER GetDesktopWindow IN user32.dll

TRY
	LOCAL lcPROGIDmsxml as String;
		,lcPROGIDmsxsl as String;
		,lcPROGIDmstemp as String
	lcPROGIDmsxml = "Msxml2.DOMDocument" + XML_VERS
	lcPROGIDmsxsl = "Msxml2.FreeThreadedDOMDocument" + XML_VERS
	lcPROGIDmstemp = "Msxml2.XSLTemplate" + XML_VERS
	*/////////////////////////////////////////////////
	*/ Try do XML + XSL => OUT transformation 
	LOCAL loMsXml as Msxml2.DOMDocument;
		,loMsXsl as Msxml2.FreeThreadedDOMDocument;
		,loMsPrc as Msxml2.XSLTemplate;
		,lobjXSLTProc as Msxml2.IXSLProcessor;
		,lbParseError as Boolean  
	loMsXml = CREATEOBJECT(lcPROGIDmsxml)
	loMsXsl = CREATEOBJECT(lcPROGIDmsxsl)
	loMsPrc = CREATEOBJECT(lcPROGIDmstemp)
	*
	*-- Load XML
	WITH loMsXml
		.async = .F.  
		.load(lcXmlFile)	&& Load XML-file
		IF .parseError.errorCode != 0
			lbParseError = .T.
			ShowXmlErr(.parseError)
		ENDIF
	ENDWITH	
	IF !lbParseError
		*
		*-- Load XSL
		WITH loMsXsl
			.async = .F.   
			.load(lcXslFile)	&& Load XSL-file
			IF .parseError.errorCode != 0
				lbParseError = .T.
				ShowXmlErr(.parseError)
			ENDIF
		ENDWITH
	ENDIF		
	IF !lbParseError
		*
		*-- XSLT transformation 
		loMsPrc.stylesheet = loMsXsl.documentElement
		lobjXSLTProc = loMsPrc.createProcessor()
		IF VARTYPE(lobjXSLTProc) = "O"
			lobjXSLTProc.input = loMsXml
			IF lobjXSLTProc.transform()
				LOCAL lcOutPut as String
				 
				IF FILE(lcOutFile)
					ERASE (lcOutFile)
				ENDIF
				LOCAL lnBytes as Number
				lnBytes = 0
				lnBytes = STRTOFILE(lobjXSLTProc.output, lcOutFile, 0)	 	
				IF lnBytes > 0 AND FILE(lcOutFile)
					LOCAL lnRetCode as Number
					lnRetCode = 0 
					lnRetCode = ShellExecute(GetDesktopWindow(), "open", lcOutFile, "", "", SW_NORMAL)
					IF lnRetCode > 32
						lbResult = .T.
					ELSE
						ERROR "ShellExecute: errorcode = " + LTRIM(STR(lnRetCode))
					ENDIF	
				ELSE
					ERROR 101, lcOutFile	
				ENDIF
			ELSE		
				ERROR "Error on XML + XSL => XML transformation"	
			ENDIF
		ELSE
			ERROR "Can not createProcessor()"	
		ENDIF
	ENDIF	
CATCH TO oErr
	MESSAGEBOX( "Error: " + LTRIM(STR(oErr.ErrorNo)) + CRLF ; 
    	+ "LineNo: " + LTRIM(STR(oErr.LineNo)) + CRLF ;  
    	+ "Message: " + oErr.Message,16, _SCREEN.Caption)
FINALLY
	STORE NULL TO ;
		loMsXml, loMsXsl, loMsPrc, lobjXSLTProc
ENDTRY

CLEAR DLLS

FUNCTION ShowXmlErr
LPARAMETERS toXmlErr as Msxml2.IXMLDOMParseError
	IF VARTYPE(toXmlErr) # 'O'
		RETURN .F.
	ENDIF	 
	WITH toXmlErr  
		lcMsg = "Error loading '" + ALLTRIM(.url) + "'" 
		lcMsg = lcMsg + CRLF + "Code: " + TRANSFORM(.errorCode, '@0')
		IF !EMPTY(.reason)
			lcMsg = lcMsg + CRLF + "Reason: " + ALLTRIM(.reason)
		ENDIF	
		IF !EMPTY(.filepos)
			lcMsg = lcMsg + CRLF + "Filepos: " + TRANSFORM(.filepos)
		ENDIF
		IF !EMPTY(.linepos)
			lcMsg = lcMsg + CRLF + "Linepos: " + TRANSFORM(.linepos)
		ENDIF
		IF !EMPTY(.line)
			lcMsg = lcMsg + CRLF + "Line: " + TRANSFORM(.line)
		ENDIF
		IF !EMPTY(.srcText)
			lcMsg = lcMsg + CRLF + "Text: " + ALLTRIM(.srcText)
		ENDIF
		MESSAGEBOX(lcMsg, 16, _SCREEN.Caption)	
	ENDWITH	
ENDFUNC