<?xml version="1.0" encoding="windows-1251" ?>
<!-- file: convert.xslt -->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
	xmlns:msdata="urn:schemas-microsoft-com:xml-msdata"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	exclude-result-prefixes="xsl msxsl xsd msdata xsi">
	
	<xsl:output method="xml" 
		indent="no"
		encoding="windows-1251" 
		omit-xml-declaration="yes" />

	<xsl:param name="prmFileReplacements">
		<xsl:text>replacements.xml</xsl:text>
	</xsl:param>
	<xsl:variable name="varReplacementsDoc">
		<xsl:copy-of select="document($prmFileReplacements)" />
	</xsl:variable>
	
	<xsl:key name="fieldKey" match="//DataSet/field" use="@oldName" />
	
	<xsl:strip-space elements="*" />
	
	<xsl:template match="/">
		<xsl:text disable-output-escaping="yes"><![CDATA[<?xml version="1.0" encoding="windows-1251" standalone="yes" ?>]]></xsl:text>
		<xsl:text>&#xD;&#xA;</xsl:text>
		<xsl:apply-templates select="/./*" />
	</xsl:template>
	
	<xsl:template match="xsd:element">
		<xsl:variable name="varOldName">
			<xsl:value-of select="@name" />
		</xsl:variable>
		<xsl:variable name="varNewName">
			<xsl:call-template name="GetNewName">
				<xsl:with-param name="prmOldName" select="$varOldName" />
			</xsl:call-template>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="string-length($varNewName)>0">
				<xsd:element name='{$varNewName}'>
					<xsl:copy-of select="*" />
				</xsd:element> 
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:apply-templates select="@*|node()" />
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="@*|node()">
		<xsl:variable name="varOldName">
			<xsl:if test="local-name()=name()">
				<xsl:value-of select="local-name()" />
			</xsl:if>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="string-length($varOldName)>0">
				<xsl:variable name="varNewName">
					<xsl:call-template name="GetNewName">
						<xsl:with-param name="prmOldName" select="$varOldName" />
					</xsl:call-template>
				</xsl:variable>
				<xsl:choose>
					<xsl:when test="string-length($varNewName)>0">
						<xsl:element name="{$varNewName}">
							<xsl:value-of disable-output-escaping="yes" select="text()" />
						</xsl:element>
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy>
							<xsl:apply-templates select="@*|node()" />
						</xsl:copy>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:apply-templates select="@*|node()" />
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="GetNewName">
		<xsl:param name="prmOldName" />
		<xsl:for-each select="msxsl:node-set($varReplacementsDoc)/*">
			<xsl:value-of select="key('fieldKey', $prmOldName)/@newName" />
		</xsl:for-each>
	</xsl:template>
	
</xsl:stylesheet>